---
workflow:
  name: "Deployment pipeline - $WORKFLOW_NAME"
  rules:
    - when: always

stages:
  - deploy
  - deploy-wc
  - update
  - update-wc
  - deployment-test
  - delete

default:
  tags:
    - gitlab-org-docker
  image: $CI_IMAGE
  before_script:
    - |
      echo -e "[\\e[1;94mEnvironment INFO\\e[0m]"
      echo "  CAPO_TAG = $CAPO_TAG"
      echo "  OCI_TAG = ${OCI_TAG:-'N/A'}"
      echo "  ENV_NAME = $ENV_NAME"
      echo "  KIND_CLUSTER_NAME = $KIND_CLUSTER_NAME"
      echo "  BOOTSTRAP_WATCH_TIMEOUT_MIN = $BOOTSTRAP_WATCH_TIMEOUT_MIN"
      echo -e "[\\e[1;94mCommon cluster INFO\\e[0m]"
      echo "  REMOTE_VALUES = ${REMOTE_VALUES:-'N/A'}"
      echo -e "[\\e[1;94mManagement cluster INFO\\e[0m]"
      echo "  MANAGEMENT_CLUSTER_NAME = $MANAGEMENT_CLUSTER_NAME"
      echo "  MGMT_ADDITIONAL_VALUES = ${MGMT_ADDITIONAL_VALUES:-'N/A'}"
      echo "  MGMT_INITIAL_ADDITIONAL_VALUES = ${MGMT_INITIAL_ADDITIONAL_VALUES:-'N/A'}"
      echo "  MGMT_UPDATE_ADDITIONAL_VALUES = ${MGMT_UPDATE_ADDITIONAL_VALUES}"
      echo "  MGMT_INITIAL_REVISION = ${MGMT_INITIAL_REVISION:-'N/A'}"
      echo "  MGMT_UPDATE_REVISION = ${MGMT_UPDATE_REVISION:-'N/A'}"
      echo "  MGMT_WATCH_TIMEOUT_MIN = ${MGMT_WATCH_TIMEOUT_MIN}"
      echo "  APPLY_WATCH_TIMEOUT_MIN = ${APPLY_WATCH_TIMEOUT_MIN}"
      echo -e "[\\e[1;94mWorkload cluster INFO\\e[0m]"
      echo "  WORKLOAD_CLUSTER_NAME = $WORKLOAD_CLUSTER_NAME"
      echo "  WC_ADDITIONAL_VALUES = ${WC_ADDITIONAL_VALUES:-'N/A'}"
      echo "  WC_INITIAL_ADDITIONAL_VALUES = ${WC_INITIAL_ADDITIONAL_VALUES:-'N/A'}"
      echo "  WC_UPDATE_ADDITIONAL_VALUES = ${WC_UPDATE_ADDITIONAL_VALUES}"
      echo "  WC_INITIAL_REVISION = ${MGMT_INITIAL_REVISION:-'N/A'}"
      echo "  WC_UPDATE_REVISION = ${MGMT_UPDATE_REVISION:-'N/A'}"
      echo "  APPLY_WC_WATCH_TIMEOUT_MIN = ${APPLY_WC_WATCH_TIMEOUT_MIN}"
  cache:
    - key: toolbox  # cache share by all jobs
      paths:
        - ./bin/
